/* Programme en mai-juin 1996 par Jean-Francois Lozevis
   Emulateur Spectrum 48 ko classique
   pour Linux avec architecture 386 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>                                             
#include <string.h>
#include <memory.h>

#include "hash.h"
#include "compile.h"
#include "macro.h"

struct macro macros[MAX_MACRO_DEPTH];
struct macro *cur_macro=NULL;
extern int debogue;
extern FILE *fout;
int lastCar;
int (*getcar)(void);
int disableMacros=0;

static int diese(void);
static int getCarIf(void);
    
static int getCarFile(void) {
	int c;                    
	struct macro *pm;
	
	switch (c=fgetc(cur_macro->u.f.file)) {
		case '#':
			return lastCar=diese();
		case 10:
			line++;
			if (debogue)
				fprintf(fout,"@%d@",line);
			return lastCar=10;
		case EOF:
			if (getcar==getCarIf)
				own_error("Missing #endif or #else in file");
			if (cur_macro==macros)
				return lastCar=EOF;
			else {          
				fclose(cur_macro->u.f.file);
				free(cur_macro->u.f.name_file);
				cur_macro--;
				getcar=cur_macro->routine;
				for (pm=cur_macro;pm->routine!=getCarFile && (pm->routine!=getCarIf || pm->oldroutine!=getCarFile);pm--)
					;
				line=pm->u.f.line;
				name_file=pm->u.f.name_file;
				if (debogue)
					fprintf(fout,"@f%s@@%d@",name_file,line);
				return getCar();
			}
		default:
			return lastCar=c;
	}
}

int getCarStr(void) {                                   
	int c,i;
	
	switch (c=*cur_macro->u.m.str++) {
		case '#':
			return lastCar=diese();
		case 0:                                 
			if ((lastCar=cur_macro->u.m.lastCar)!=0) {
				cur_macro->u.m.str--;
				cur_macro->u.m.lastCar=0;
				return lastCar;
			}
			if (getcar==getCarIf) {
				fprintf(stderr,"Missing #else or #endif in macro %s",cur_macro->u.m.name);
				own_error(NULL);
			}
			if (cur_macro->u.m.strwhile) {
				long ok;
				struct macro *m=cur_macro;
				cur_macro->u.m.str--;
				newMacroFile();
				cur_macro->u.m.name="__whilecond__";
				cur_macro->routine=getcar=getCarStr;
				cur_macro->u.m.str=m->u.m.strwhile;
				cur_macro->u.m.str2free=NULL;
				cur_macro->u.m.strwhile=NULL;
				cur_macro->u.m.npar=0;
				cur_macro->u.m.lastCar=0;
				cur_macro->u.m.params=NULL;
				ok=calcExpr();
				cur_macro=m;
				if (ok) {
					m->u.m.str=m->u.m.str2free;
					return getcar();
				}
				else
					free(m->u.m.strwhile);
			}
			if (cur_macro->u.m.str2free)
				free(cur_macro->u.m.str2free);
			for (i=1;i<=cur_macro->u.m.npar;i++)
				free(cur_macro->u.m.params[i-1]);
			if (cur_macro->u.m.npar>0)
				free(cur_macro->u.m.params);
			cur_macro--;
			getcar=cur_macro->routine;
			return getCar();
		default:
			return lastCar=c;
	}
}                                      
                                               
static int discardBlock(void) {
  int prof=0;
  
  disableMacros=1;
  while (1) {
    switch ((*cur_macro->oldroutine)()) {
    case NUMELSE:
      if (!prof) {
	if (cur_macro->numEnd[cur_macro->nbEnd-1]==NUMEND)
	  own_error("#endif expected");
	disableMacros=0;
	return NUMELSE;
      }
      continue;
    case NUMEND:
      if (!prof) {
	disableMacros=0;
	return NUMEND;
      }
      prof--;
      continue;
    case NUMIF:
      prof++;
      continue;
    }
  }
}
    	
                      
                                               
static int getCarIf(void) {
	int c;
	
	switch (c=(*cur_macro->oldroutine)()) {
		case NUMELSE:
			if (cur_macro->numEnd[cur_macro->nbEnd-1]==NUMELSE)
				own_error("# endif expected");
			else {
				discardBlock();
			}
		case NUMEND:
			if (cur_macro->nbEnd==1)
				getcar=cur_macro->routine=cur_macro->oldroutine;
			else {
				cur_macro->nbEnd--;
			}
			return getCar();
		default:
			return lastCar=c;              
	}
}	

void newMacroFile(void) {
	cur_macro++;
	if (cur_macro>=macros+MAX_MACRO_DEPTH)
		own_error("Too many nested files and macros");
}

/* creates a malloced C string */
char *getStr(int lC,int twice) {
	char *str;
	int c;   
	unsigned nj,j;
	
	str=own_malloc(STEP_BUFFER);
	*str=lastCar;
	nj=STEP_BUFFER;
	j=0;
	do {
		c=getCar();
		if (c==EOF)
			uef();
		j++;
		if (j>=nj) {                 
			if (nj>40000u)
				own_error("Buffer too long");
			nj>>=1;
			nj*=3;
			if (!(str=realloc(str,nj)))
				own_error("Out of memory");
		}
		str[j]=c;
	} while (c!=lC || (twice && getCar()==lC));
	str[j]=0;
	if (!(str=realloc(str,j+1)))
		own_error("Out of memory");
	return str;
}                    
                                 
/* creates a malloced char C string */
static char *getSymbol(void) {
	int c,i;          
	char chn[STEP_BUFFER],*str;
	
	/* chn=own_malloc(STEP_BUFFER); */
	chn[0]=lastCar;
	i=1;
	do {
		c=getCar();
		if (c==EOF)
			uef();
		if (i>=STEP_BUFFER)
			own_error("Too long symbol");
		chn[i++]=c;
	} while (isalnum(c) || c=='_');
	chn[i-1]=0;
	str=own_malloc(i);
	memcpy(str,chn,i);
	return str;
}                      
                           
/* creates a malloced char C string */                           
char *getSymbol2(void) {
	while (!isalnum(getCar()) && lastCar!='_')
		;
	return getSymbol();
}
                
char *getParam(int c) {
	char *chn;

	if (lastCar=='$') {
		getCar();
		chn=getStr('$',1);
		if (isspace(lastCar))
			while (isspace(getCar()))
				;
		if (lastCar!=c)
			own_error(") or , expected");
		return chn;
	}
	return getStr(c,0);
}
                
                
static int newStr(char *name,char *str,int npar,int lCar) {
	int i,c;
	char **params = NULL;

	if (npar) {
		params=(char **) own_malloc(npar*sizeof(char *));
		if (lastCar!='(')
			while ((c=getCar())!='(')
				if (c==EOF)
					uef();
		getCar();
		for (i=1;i<=npar-1;i++) {
			params[i-1]=getParam(',');
			getCar();
		}
		params[npar-1]=getParam(')');
		lCar=0;
	}				
	newMacroFile();         
	cur_macro->u.m.name=name;    
	cur_macro->routine=getcar=getCarStr;
	cur_macro->u.m.str=str;
	cur_macro->u.m.str2free=cur_macro->u.m.strwhile=NULL;
	cur_macro->u.m.npar=npar;                
	cur_macro->u.m.lastCar=lCar!='!'?lCar:0;
	cur_macro->u.m.params=params;
	return getCar();
}           

static int calcul(void) {
	static char chn[20];
	
	if (disableMacros)
		return NUMMACRO;
#ifdef _DOS
	ltoa(calcExpr(),chn,10);
#else
	sprintf(chn,"%ld",calcExpr());
#endif
	newMacroFile();
	cur_macro->routine=getcar=getCarStr; 
	cur_macro->u.m.name="__calcul__";
	cur_macro->u.m.str=chn+1;
	cur_macro->u.m.str2free=cur_macro->u.m.strwhile=NULL;
	cur_macro->u.m.npar=0;
	cur_macro->u.m.lastCar=0;
	return chn[0];
}                                                     

static int newLabel(void) {
	static char chn[20];
	static long numLabel=0;
	
	if (disableMacros)
		return NUMMACRO;
	sprintf(chn,"%ld",++numLabel);
	newMacroFile();
	cur_macro->routine=getcar=getCarStr; 
	cur_macro->u.m.name="__newlabel__";
	cur_macro->u.m.str=chn+1;
	cur_macro->u.m.str2free=cur_macro->u.m.strwhile=NULL;
	cur_macro->u.m.npar=0;
	cur_macro->u.m.lastCar=lastCar;
	return chn[0];
}                                                     

static int defMacro(void) {
	char *s,*str;
	int n,c;
	
	if (disableMacros)
		return NUMMACRO;
	str=getSymbol2();
	while ((c=getCar())<'0' || c>'9')
		if (c==EOF)
			uef();
	n=(int) getNum();
	if (n<0 || n>10000)
		own_error("Negative or >10000 number of arguments forbidden");
	getCar();
	s=getStr(257,0);
	hash_add(str,n,s);
	return getCar();
}

static int endMacro(void) {
	return 257;
}

static int defDefine(void) {
	char *s,*str;
	
	if (disableMacros)
		return NUMMACRO;
	str=getSymbol2();
	if (lastCar==10) {
		s=own_malloc(2);
		s[0]=' ';
		s[1]=0;
	}
	else {
		getCar();
		s=getStr(10,0);
	}
	hash_add(str,0,s);
	return getCar();
}          

static int redefineMacro(void) {
	char *s,*str;
	
	if (disableMacros)
		return NUMMACRO;
	str=getSymbol2();
	if (lastCar==10) {
		s=own_malloc(2);
		s[0]=' ';
		s[1]=0;
	}
	else {
		getCar();
		s=getStr(10,0);
	}
	if (hash_exist(str))
		hash_del(str);
	hash_add(str,0,s);
	return getCar();
}          

static int undefMacro(void) {
	char *chn;

	if (disableMacros)
		return NUMMACRO;
	hash_del(chn=getSymbol2());
	free(chn);
	return getCar();
}
              
void open_file(char *name) {
	name_file=name;
	if ((cur_macro->u.f.file=fopen(name,"rt"))==NULL) {
		fprintf(stderr,"File %s not found\n",name);
		exit(2);
	}
	if (debogue)
		fprintf(fout,"@f%s@@1@",name);
	cur_macro->u.f.name_file=name;
	line=1;
	cur_macro->routine=getcar=getCarFile;
}

static int includeMacro(void) {
	struct macro *pm;
	char *s;

	if (disableMacros)
		return NUMMACRO;
	for (pm=cur_macro;pm->routine!=getCarFile;pm--)
		;
	pm->u.f.line=line;
	while (isspace(getCar()))
		;
	if (lastCar!='"')
		own_error("\" expected");
	getCar();
	s=getStr('"',0);
	newMacroFile();    
	open_file(s);
	return getCar();
}                                    

int elseMacro(void) {
	return NUMELSE;
}

int endifMacro(void) {
	return NUMEND;
}

int makeIf(int ok) {
	if (getcar!=getCarIf) {
		cur_macro->oldroutine=getcar;
		cur_macro->routine=getcar=getCarIf;
		cur_macro->nbEnd=1;
	}
	else if (++cur_macro->nbEnd>MAX_MACRO_DEPTH)
		own_error("Too much nested #if");
	if (ok)
		cur_macro->numEnd[cur_macro->nbEnd-1]=NUMEND;
	else {
		cur_macro->numEnd[cur_macro->nbEnd-1]=NUMELSE;
		if (discardBlock()==NUMEND && --cur_macro->nbEnd==0)
			getcar=cur_macro->routine=cur_macro->oldroutine;
	}
	return getCar();
}
		
                           
int ifdefMacro(void) {
	char *chn;
	int ok;

	if (disableMacros)
		return NUMIF;
	ok=hash_exist(chn=getSymbol2());
	free(chn);
	return makeIf(ok);
}

static int ifndefMacro(void) {
	char *chn;
	int ok;

	if (disableMacros)
		return NUMIF;
	ok=hash_exist(chn=getSymbol2());
	free(chn);
	return makeIf(!ok);
}

static int ifzMacro(void) {
	long val;

	if (disableMacros)
		return NUMIF; 
	while (getCar()!='[')
		;     
	val=calcExpr();
	getCar();
	return makeIf(val==0l);
}

static int ifnzMacro(void) {
	long val;
	
	if (disableMacros)
		return NUMIF; 
	while (getCar()!='[')
		;
	val=calcExpr();
	getCar();
	return makeIf(val!=0l);
}

void init_macro(void) {
	static char *spec_symbols[]={
		"macro",
		"endm",
		"define",
		"undef",
		"include",
		"ifdef",
		"ifndef",
		"else",
		"endif",
		"lefttext",
		"ifz",
		"ifnz",
		"redefine",
		"textline",
		"newlabel",
		"while",
		"endwhile"};
	int i;
	for (i=1;i<=17;i++)
		hash_add(spec_symbols[i-1],-i,NULL);
	cur_macro=macros;
}

static int symbole(void) {
	extern int textlineMacro(void);
	extern int textleftMacro(void);
	extern int whileMacro(void);
	extern int endwhileMacro(void);
	struct hash_base *ptr;      
	static int (*tab_spec_symbol[])(void) = {
		defMacro,endMacro,defDefine,undefMacro,includeMacro,
		ifdefMacro,ifndefMacro,elseMacro,endifMacro,textleftMacro,
		ifzMacro,ifnzMacro,redefineMacro,textlineMacro,newLabel,
		whileMacro,endwhileMacro
	};
	char *chn;     
	
	ptr=hash_seek(chn=getSymbol());
	if (!ptr) {
		if (disableMacros) {
			free(chn);
			return NUMMACRO;
		}
		fprintf(stderr,"Symbol %s not defined",chn);
		own_error(NULL);
	}
	free(chn);
	if (ptr->npar<0)
		return (*tab_spec_symbol[-ptr->npar-1])();
	else
		return disableMacros?NUMMACRO:newStr(ptr->name,ptr->str,ptr->npar,lastCar);
}

static int diese(void) {
	int i;

	while (isspace(getCar()) && lastCar!=NUMMACRO)
		;
	switch (lastCar) {
		case '!':
			return '#';
		case '@':
			if (getcar!=getCarFile)
				own_error("Comments can not be used in macros");
			i=1;
			while (i) {
				switch(fgetc(cur_macro->u.f.file)) {
					case '#':
						if (fgetc(cur_macro->u.f.file)=='@')
							i++;
						break;
					case 10:
						line++;
						break;
					case EOF:
						uef();
					case '@':
						i--;
						break;
				}                             
			}
			return getCar();
		case EOF:
			uef();
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		  if (disableMacros)
		    return NUMMACRO;
		  i=(int) getNum();
		  if (cur_macro->routine!=getCarStr && 
		      (cur_macro->routine!=getCarIf ||
		       cur_macro->oldroutine!=getCarStr))
		    own_error("Parameters must be used in macros");
        	if (i<1 || i>cur_macro->u.m.npar) {
		  fprintf(stderr,"Macro %s only takes %d parameters",
			  cur_macro->u.m.name,
			  cur_macro->u.m.npar);
		  own_error(NULL);
        	}        
        	return newStr("__parameter__",cur_macro->u.m.params[i-1],0,lastCar);
        case '[':
			if (disableMacros)
				return NUMMACRO;
        	return calcul();
        default:
        	return lastCar!=NUMMACRO?symbole():NUMMACRO;
      }
 }

 void own_error(char *chn) {
	int is_macro;
	fprintf(stderr,"%s\nError line %d in file %s\n",chn?chn:"",line,name_file);
//	printAllMacros();
	if (cur_macro) {
		while(1) {
			is_macro=cur_macro->routine==getCarStr || (cur_macro->routine==getCarIf && cur_macro->oldroutine==getCarStr);
			fprintf(stderr,is_macro?"Macro %s\n":"File %s\n",is_macro?cur_macro->u.m.name:cur_macro->u.f.name_file);
			if (cur_macro==macros)
				break;
			cur_macro--;
		}
	}		
	exit(1);
}
                   
