/* Programme en mai-juin 1996 par Jean-Francois Lozevis
   Emulateur Spectrum 48 ko classique
   pour Linux avec architecture 386 */
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "hash.h"
#include "compile.h"
#include "macro.h"

static void StrCat(char **ps,char *s,int *maxsize,int *size) {
	int ssize;
	char *si;

	ssize=strlen(s);
	if (*size+ssize>*maxsize) {
		if ((*ps=realloc(*ps,*maxsize*=2))==NULL)
			own_error("Out of Memory");  
		}    
	for (si=*ps+*size-1;*s;*si++=*s++)
		;              
	*si=0;
	*size+=ssize;
}

int textLines;

static void defineVarNumber(char *str,long number) {
	char word[10],*chn;

	sprintf(word,"%ld",number);
	chn=own_malloc(strlen(word)+1);
	strcpy(chn,word);
	hash_add(str,0,chn);
}

int textlineMacro(void) {
	defineVarNumber(getSymbol2(),textLines);
	return getCar();
}

int textleftMacro(void) {
  char word[STEP_BUFFER*2],*chn,*str;
  int i,sizeline,lword,lwordp,size,maxsize,c;
  
  if (disableMacros)
    return NUMMACRO;    
  i=lword=lwordp=textLines=0;
  size=3;
  chn=own_malloc(maxsize=STEP_BUFFER);
  chn[0]='\t';chn[1]='"';chn[2]=0;
  str=getSymbol2();
  while (isspace(getCar()))
    ;
  sizeline=(int) getNum();
  while (isspace(getCar()))
    ;
  while (1) {
    switch(c=lastCar) {
    case EOF:
      uef();
    case '\n':               
    case '\t':
    case ' ':
      getCar();
      if (lword) {
	if (i+1+lword>sizeline) {
	  /*for (s=spaces;i+1+lword<sizeline;s++)
	   *s=' ';*/
	  StrCat(&chn,"\"\n\t\"",&maxsize,&size);
	  textLines++;
	  i=0;
	}
	word[lwordp]=' ';    
	word[lwordp+1]=0;
	i+=lword+1;
	lword=lwordp=0;
	StrCat(&chn,word,&maxsize,&size);
      }       
      if (c=='\n' && lastCar=='\n') {
	StrCat(&chn,"\"\n\t\"\"\n\t\"",&maxsize,&size);
	textLines+=2;
	i=0;
      }
      break;
    case '\\':
      switch (getCar()) {
      case '\\':
	goto defaults;
      case '0':
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
	word[lwordp++]='\\';
	word[lwordp++]=lastCar;
	getCar();
	break;
      default:
	own_error("Digit or \\ expected");
      }
      break;
    case '!':
      if (getCar()!='!') {
	StrCat(&chn,"\"\n",&maxsize,&size);
	newMacroFile();
	cur_macro->routine=getcar=getCarStr;
	cur_macro->u.m.name="lefttext";
	cur_macro->u.m.str=cur_macro->u.m.str2free=chn;
	cur_macro->u.m.strwhile=NULL;
	cur_macro->u.m.npar=0; 
	cur_macro->u.m.lastCar=0;
	defineVarNumber(str,textLines+1);
	return lastCar;
      }
    default:
    defaults:
      getCar();
      word[lwordp++]=c;
      lword++;
      if (c=='"')
	word[lwordp++]='"';
      if (lword>=STEP_BUFFER-2)
	own_error("Too long a word");
    }
  }
}

int whileMacro(void) {
	char *cond,*body;
	while (getcar()!='[')
		;
	getcar();
	cond=getStr('\n',0);getcar();
	body=getStr(NUMENDWHILE,0);
	newMacroFile();
	cur_macro->u.m.name="__while__";
	cur_macro->routine=getcar=getCarStr;
	cur_macro->u.m.str="";
	cur_macro->u.m.str2free=body;
	cur_macro->u.m.strwhile=cond;
	cur_macro->u.m.npar=0;
	cur_macro->u.m.lastCar=0;
	cur_macro->u.m.params=NULL;
	return getCar();
}

int endwhileMacro(void) {
	return NUMENDWHILE;
}




