/* Programme en mai-juin 1996 par Jean-Francois Lozevis
   Emulateur Spectrum 48 ko classique
   pour Linux avec architecture 386 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>

#include "son.h"

#define MAXSIZESON 1000

int hdl_son;

void InitSon(void) {
  int tmp;
  int samplesize=8;
  int dsp_stereo=0;
  int dsp_speed=FREQUENCE;
  // int frag=0x00010006;
  int buf_size=0;

  if ((hdl_son=open("/dev/audio", O_WRONLY))==-1) {
    fprintf(stderr,"Impossible d'ouvrir /dev/dsp\n");
    exit(1);
  }

  ioctl(hdl_son, SNDCTL_DSP_RESET, NULL);

  tmp = samplesize;
  ioctl(hdl_son, SNDCTL_DSP_SAMPLESIZE, &samplesize);
  if (tmp != samplesize)
  {
        fprintf(stderr, "Unable to set the sample size\n");
        exit(-1);
  }

  if (ioctl (hdl_son, SNDCTL_DSP_STEREO, &dsp_stereo)==-1)
  {
      fprintf (stderr, "Unable to set mono/stereo\n");
      perror ("Sound driver ioctl ");
      exit (-1);
  }

  if (ioctl (hdl_son, SNDCTL_DSP_SPEED, &dsp_speed) == -1)
    {
      fprintf (stderr, "Unable to set audio speed\n");
      perror ("Sound driver ioctl ");
      exit (-1);
    }
  ioctl(hdl_son, SNDCTL_DSP_GETBLKSIZE, &buf_size);
  // fprintf(stderr,"Buf_size=%d\n",buf_size);
  //  if (ioctl(hdl_son, SNDCTL_DSP_SPEED, &freq)==-1)
    //    perror("Sound driver ioctl ");
  //  ioctl(hdl_son, SNDCTL_DSP_SETFRAGMENT, &frag);
}

int main() {
  char tampon[MAXSIZESON];
  int l;

  InitSon();
  while ((l=read(0, tampon, MAXSIZESON))>0) {
    // fprintf(stderr, "(%d)", l);
    // write(hdl_son, tampon, l>FREQUENCE/50?FREQUENCE/50:l);
    write(hdl_son, tampon, l);
    ioctl(hdl_son, SNDCTL_DSP_SYNC, NULL);
  }
  fprintf(stderr, "playson terminated (%d)\n", l);
  return 0;
}
